import java.awt.image.BufferedImage;
import java.io.File;
import javax.imageio.ImageIO;
import java.io.IOException;


// 摜RGBi[NX(bit̂Rz)
class ColorCube
{
	private int m_data[];

	// 
	public ColorCube()
	{
		// int32bitȂ̂ŁA256x256x25632ŊĂ
		m_data = new int[ 256 * 256 * 256 / 32 ];
		// Sf[^0ɂ
		for ( int i = 0; i < m_data.length; ++ i ) m_data[ i ] = 0;
	}

	
	// RGB̒lz̓YvZ
	public int data_position( int r, int g, int b )
	{
		if ( ( 0 > r ) || ( 255 < r ) ) return -1;
		if ( ( 0 > g ) || ( 255 < g ) ) return -1;
		if ( ( 0 > b ) || ( 255 < b ) ) return -1;

		return ( ( r * 256 + g ) * 256 + b ) / 32;
	}
	

	// wRGB̈ʒubit=1ݒ
	public boolean set( int r, int g, int b )
	{
		int dpos;

		dpos = data_position( r, g, b );
		if ( 0 > dpos ) return false;

		//
		m_data[ dpos ] = m_data[ dpos ] |
				 ( (int)0x80000000 >> ( b % 32 ) );

		return true;
	}
	

	// wRGB̈ʒubit1𔻒
	public boolean get( int r, int g, int b )
	{
		int dpos;

		dpos = data_position( r, g, b );
		if ( 0 > dpos ) return false;

		//
		if ( 0 != ( m_data[ dpos ] &
			 ( (int)0x80000000 >> ( b % 32 ) ) ) ) return true;

		return false;
	}


	// wRGB͈̔͂bit=1̌Ԃ
	public int pixel_number( int rmin, int rmax, int gmin, int gmax,
								 int bmin, int bmax )
	{
		int r, g, b;
		int pixnum;

		pixnum = 0;
		for ( r = rmin; r <= rmax; ++ r ) {
			for ( g = gmin; g <= gmax; ++ g ) {
				for ( b = bmin; b <= bmax; ++ b ) {
					if ( true == get( r, g, b ) ) ++ pixnum;
				}
			}
		}

		return pixnum;
	}


	// wRGB͈̔͂RŔɕrlԂ
	public int get_median_r( int rmin, int rmax,
					 int gmin, int gmax, int bmin, int bmax )
	{
		int r, rrange;
		int pixnum[], pnum, pixtotal, pixhalf;
		
		rrange = rmax - rmin + 1;
		if ( 0 > rrange ) return rmin;

		//
		pixnum = new int[ rrange ];
		for ( int i = 0; i < rrange; ++ i ) pixnum[ i ] = 0;

		//
		pixtotal = 0;
		for ( r = rmin; r <= rmax; ++ r ) {
			pixnum[ r - rmin ] = pixel_number( r, r, gmin, gmax,
									 bmin, bmax );
			pixtotal = pixtotal + pixnum[ r - rmin ];
		}

		//
		pixhalf = pixtotal / 2;
		pnum = 0;
		for ( r = rmin; r <= rmax; ++ r ) {
			if ( ( pnum + pixnum[ r - rmin ] ) >= pixhalf ) return r;
			pnum = pnum + pixnum[ r - rmin ];
		}

		//
		return -1;
	}


	// wRGB͈̔͂GŔɕglԂ
	public int get_median_g( int rmin, int rmax,
					 int gmin, int gmax, int bmin, int bmax )
	{
		int g, grange;
		int pixnum[], pnum, pixtotal, pixhalf;
		
		grange = gmax - gmin + 1;
		if ( 0 > grange ) return gmin;

		//
		pixnum = new int[ grange ];
		for ( int i = 0; i < grange; ++ i ) pixnum[ i ] = 0;

		//
		pixtotal = 0;
		for ( g = gmin; g <= gmax; ++ g ) {
			pixnum[ g - gmin ] = pixel_number( rmin, rmax, g, g,
									 bmin, bmax );
			pixtotal = pixtotal + pixnum[ g - gmin ];
		}

		//
		pixhalf = pixtotal / 2;
		pnum = 0;
		for ( g = gmin; g <= gmax; ++ g ) {
			if ( ( pnum + pixnum[ g - gmin ] ) >= pixhalf ) return g;
			pnum = pnum + pixnum[ g - gmin ];
		}

		//
		return -1;
	}


	// wRGB͈̔͂BŔɕblԂ
	public int get_median_b( int rmin, int rmax,
					 int gmin, int gmax, int bmin, int bmax )
	{
		int b, brange;
		int pixnum[], pnum, pixtotal, pixhalf;
		
		brange = bmax - bmin + 1;
		if ( 0 > brange ) return bmin;

		//
		pixnum = new int[ brange ];
		for ( int i = 0; i < brange; ++ i ) pixnum[ i ] = 0;

		//
		pixtotal = 0;
		for ( b = bmin; b <= bmax; ++ b ) {
			pixnum[ b - bmin ] = pixel_number( rmin, rmax, gmin, gmax,
										 b, b );
			pixtotal = pixtotal + pixnum[ b - bmin ];
		}

		//
		pixhalf = pixtotal / 2;
		pnum = 0;
		for ( b = bmin; b <= bmax; ++ b ) {
			if ( ( pnum + pixnum[ b - bmin ] ) >= pixhalf ) return b;
			pnum = pnum + pixnum[ b - bmin ];
		}

		//
		return -1;
	}
}


// ꂽRGB͈̔͂Ɗ܂܂F̌i[NX
class ColorCore
{
	public int rmin = 0, rmax = 0;
	public int gmin = 0, gmax = 0;
	public int bmin = 0, bmax = 0;
	public int pixnumber = 0;
}


// fBAJbg{
public class MedianCut {
	public static void main( String[] args ) {
		boolean result;		// ʊi[tO
		int     maxcorecount;	//F̐F

		// ColorCube
		ColorCube cube = new ColorCube();

		// ColorCore
		int corenumber;
		ColorCore core[];

		// t@C
		String inname, outname;
		// 摜i[NX
		BufferedImage img = null;

		// ͂3ȏォ𒲂ׂ
		if ( 3 > args.length ) {
			// ͂Q̏ꍇAgp@\
			System.out.println(
				 "MedianCut [JPEG] [oJPEG] [F]" );
			return;
		}

		// JPEGinnameɑigq".jpg"ȗȂj
		inname  = args[ 0 ];
		// oJPEGoutnameɑigq".jpg"ȗȂj
		outname = args[ 1 ];
		
		// ϊARAɑ
		try {
			maxcorecount = Integer.valueOf( args[ 2 ] );
			if ( 2 > maxcorecount ) {
				System.out.println( "FQȏw肵Ă" );
				return;
			}
			core = new ColorCore[ maxcorecount ];
		}
		catch( NumberFormatException ne )
		{
			System.out.println( "sł" );
			return;
		}		
		
		// JPEG̓ǂݍ
		try {
			// inname(JPEG)ǂݍimgɃZbg
			img = ImageIO.read( new File( inname ) );
		} catch (Exception e) {
			// inname(JPEG)̓ǂݍ݂ɎsƂ̏
			 e.printStackTrace();
			return;
		}

		// 摜̐F̎`FbN
		if ( BufferedImage.TYPE_3BYTE_BGR != img.getType() )
		{
			System.out.println( "ΉĂȂJ[fłI("
									 + inname +")" );
			return;
		}

		// F
		int x, y;
		int width, height;
		int r, g, b, color;
		int rmin, rmax;
		int gmin, gmax;
		int bmin, bmax;
		int dr, dg, db, dmax;
		int maxcore, maxpix;
		int cutp;

		// 摜TCY̎擾
		width = img.getWidth();
		height= img.getHeight();

		// ColorCubeRGBli[
		rmin = gmin = bmin = 256;
		rmax = gmax = bmax = -1;
		for ( y = 0; y < height; ++ y ) {
			for ( x = 0; x < width; ++ x ) {
				// (x,y)̐F擾
				color = img.getRGB( x, y );

				// Fr,g,bɕ
				r = ( color >> 16 ) & 0xff;
				g = ( color >> 8 ) & 0xff;
				b = color & 0xff;

				// ColorCubergbi[
				cube.set( r, g, b );

				// r͈̔͂rmin,rmaxɊi[
				if ( r < rmin ) rmin = r;
				if ( r > rmax ) rmax = r;

				// g͈̔͂gmin,gmaxɊi[
				if ( g < gmin ) gmin = g;
				if ( g > gmax ) gmax = g;

				// b͈̔͂bmin,bmaxɊi[
				if ( b < bmin ) bmin = b;
				if ( b > bmax ) bmax = b;
			}
		}

		// ColorCube猸Fe[u쐬

		// core[]̏lݒ
		corenumber = 0;
		core[ corenumber ] = new ColorCore();
		core[ corenumber ].rmin = rmin;
		core[ corenumber ].rmax = rmax;
		core[ corenumber ].gmin = gmin;
		core[ corenumber ].gmax = gmax;
		core[ corenumber ].bmin = bmin;
		core[ corenumber ].bmax = bmax;
		core[ corenumber ].pixnumber = cube.pixel_number( rmin, rmax,
							 gmin, gmax, bmin, bmax );
		++ corenumber;

		// core̐maxcorecountɂȂ܂Ŏs
		while ( corenumber < maxcorecount ) {
			// core[]̒łfő̂̂I
			maxcore = 0;
			maxpix = 0;
			for ( int i = 0; i < corenumber; ++ i ) {
				if ( ( 0 == i ) || ( core[ i ].pixnumber > maxpix ) ) {
					maxcore = i;
					maxpix = core[ i ].pixnumber;
				}
			}

			rmin = core[ maxcore ].rmin;
			rmax = core[ maxcore ].rmax;
			gmin = core[ maxcore ].gmin;
			gmax = core[ maxcore ].gmax;
			bmin = core[ maxcore ].bmin;
			bmax = core[ maxcore ].bmax;

			// Icorer,g,b͈̔͂dr,dg,dbɑ
			dr = rmax - rmin;
			dg = gmax - gmin;
			db = bmax - bmin;
		
			// dr,dg,db̍ől߂
			dmax = Math.max( dr, Math.max( dg, db ) );
			if ( 0 == dmax ) break;

			// dr,dg,db̂Aő̐core𕪊
			if ( dmax == dr ) {
				// rcore𕪊

				// rcutpɑ
				cutp = cube.get_median_r( rmin, rmax, gmin, gmax,
										 bmin, bmax );
				if ( rmin > cutp ) break;
				// 
				core[ corenumber ] = new ColorCore();
				core[ corenumber ].rmin = cutp + 1;
				core[ corenumber ].rmax = core[ maxcore ].rmax;
				core[ corenumber ].gmin = core[ maxcore ].gmin;
				core[ corenumber ].gmax = core[ maxcore ].gmax;
				core[ corenumber ].bmin = core[ maxcore ].bmin;
				core[ corenumber ].bmax = core[ maxcore ].bmax;
				core[ corenumber ].pixnumber
					 = cube.pixel_number( cutp + 1, rmax, gmin, gmax,
										 bmin, bmax );
				++ corenumber;
				//
				core[ maxcore ].rmax = cutp;
				core[ maxcore ].pixnumber
					 = cube.pixel_number( rmin, cutp, gmin, gmax,
									 bmin, bmax );
			}
			else {
				if ( dmax == dg ) {
					// gcore𕪊

					// gcutpɑ
					cutp = cube.get_median_g( rmin, rmax, gmin, gmax,
										 bmin, bmax );
					if ( gmin > cutp ) break;
					// 
					core[ corenumber ] = new ColorCore();
					core[ corenumber ].rmin = core[ maxcore ].rmin;
					core[ corenumber ].rmax = core[ maxcore ].rmax;
					core[ corenumber ].gmin = cutp + 1;
					core[ corenumber ].gmax = core[ maxcore ].gmax;
					core[ corenumber ].bmin = core[ maxcore ].bmin;
					core[ corenumber ].bmax = core[ maxcore ].bmax;
					core[ corenumber ].pixnumber
						 = cube.pixel_number( rmin, rmax,
									 cutp + 1, gmax, bmin, bmax );
					++ corenumber;
					//
					core[ maxcore ].gmax = cutp;
					core[ maxcore ].pixnumber
						 = cube.pixel_number( rmin, rmax,
									 gmin, cutp, bmin, bmax );
				}
				else {
					// bcore𕪊

					// bcutpɑ
					cutp = cube.get_median_b( rmin, rmax, gmin, gmax,
										 bmin, bmax );
					if ( bmin > cutp ) break;
					// 
					core[ corenumber ] = new ColorCore();
					core[ corenumber ].rmin = core[ maxcore ].rmin;
					core[ corenumber ].rmax = core[ maxcore ].rmax;
					core[ corenumber ].gmin = core[ maxcore ].gmin;
					core[ corenumber ].gmax = core[ maxcore ].gmax;
					core[ corenumber ].bmin = cutp + 1;
					core[ corenumber ].bmax = core[ maxcore ].bmax;
					core[ corenumber ].pixnumber
						 = cube.pixel_number( rmin, rmax,
									 gmin, gmax, cutp + 1, bmax );
					++ corenumber;
					//
					core[ maxcore ].bmax = cutp;
					core[ maxcore ].pixnumber 
						= cube.pixel_number( rmin, rmax, gmin, gmax,
										 bmin, cutp );
				}
			}
		}

		// ColorCube猸Fe[u쐬
		int index_r[] = new int[ corenumber ];
		int index_g[] = new int[ corenumber ];
		int index_b[] = new int[ corenumber ];
		
		for ( int i = 0; i < corenumber; ++ i ) {
			// F̓RA̒SƂ
			index_r[ i ] = ( core[ i ].rmin  + core[ i ].rmax ) / 2;
			index_g[ i ] = ( core[ i ].gmin  + core[ i ].gmax ) / 2;
			index_b[ i ] = ( core[ i ].bmin  + core[ i ].bmax ) / 2;
		}

		// ̉摜̐FF
		int l, minl;
		int rl, gl, bl;
		int searchindex;
		int newcolor;
		
		for ( y = 0; y < height; ++ y ) {
			for ( x = 0; x < width; ++ x ) {
				// (x,y)̐F擾
				color = img.getRGB( x, y );

				// Fr,g,bɕ
				r = ( color >> 16 ) & 0xff;
				g = ( color >> 8 ) & 0xff;
				b = color & 0xff;

				// r,g,bɍł߂Findex猟
				rl = r - index_r[ 0 ];
				gl = g - index_g[ 0 ];
				bl = b - index_b[ 0 ];
				minl = rl * rl + gl * gl + bl * b;
				searchindex = 0;

				for ( int i = 1; i < corenumber; ++ i ) {
					//
					rl = r - index_r[ i ];
					gl = g - index_g[ i ];
					bl = b - index_b[ i ];
					l = rl * rl + gl * gl + bl * bl;
					if ( l < minl ) {
						minl = l;
						searchindex = i;
					}
				}
				
				// ł߂Fr,g,bɐݒ
				r = index_r[ searchindex ];
				g = index_g[ searchindex ];
				b = index_b[ searchindex ];
				
				// r,g,b̐F
				newcolor = ( r << 16 ) + ( g << 8 ) + b;

				// F(x,y)ɐݒ
				img.setRGB( x, y, newcolor );
			}
		}

		//@FύX摜ۑ
		try {
			// imgoutname(oJPEG)ɕۑ
			result = ImageIO.write( img, "jpeg", new File( outname ) );
		} catch ( Exception e ) {
			// outname(oJPEG)̕ۑɎsƂ̏
			e.printStackTrace();
			return;
		}

		// ɏI
		System.out.println( "ɏI܂" );
	}
} 
